﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QQGroupControLlibraries
{
    
    public partial class QQGroup : UserControl
    {
        public QQGroup()
        {
            InitializeComponent();
            collection = new QQGroupItemCollection(this);
            this.Dock = DockStyle.Fill;
        }

        QQGroupItemCollection collection;

        /// <summary>
        ///     获取包含控件中所有项的集合。
        /// </summary>
        [Description("获取包含控件中所有项的集合。")]
        public QQGroupItemCollection Items
        {
            get { return collection; }
        }
    }


    public class QQGroupItemCollection
    {
        UserControl userControl;
        public QQGroupItemCollection(UserControl uc)
        {
            this.userControl = uc;
        }
        
        private List<QQGroupItem> items = new List<QQGroupItem>();

        /// <summary>
        ///     获取集合中指定索引处的索引值。
        /// </summary>
        public QQGroupItem this[int index]
        {
            get {
                return items[index];
            }
        }

        /// <summary>
        ///     向集合中增加一项
        /// </summary>
        public QQGroupItem Add(QQGroupItem value)
        {
            items.Add(value);
            userControl.Controls.Add(value);
            return value;
        }

        /// <summary>
        ///     从 QQGroup 中移除 QQGroup.Items 集合中指定索引处的项。
        /// </summary>
        public void Remove(int value)
        {
            this.items.Remove(items[value]);
        }

        /// <summary>
        ///     从 QQGroup 中移除特定对象的第一个匹配项。
        /// </summary>
        public void Remove(QQGroupItem value)
        {
            this.items.Remove(value);
        }

        /// <summary>
        ///     清除集合中的项。
        /// </summary>
        public void Clear(){
            items.Clear();
        }

        /// <summary>
        ///     获取集合中项的数目。
        /// </summary>
        public int Count { get { return this.items.Count; } }

    }

    
}
